# SPDX-License-Identifier: GPL-2.0
%YAML 1.2
---
$id: http://devicetree.org/schemas/media/rockchip-rga.yaml#
$schema: http://devicetree.org/meta-schemas/core.yaml#

title: Rockchip 2D raster graphic acceleration controller (RGA)

description:
  RGA is a standalone 2D raster graphic acceleration unit. It accelerates 2D
  graphics operations, such as point/line drawing, image scaling, rotation,
  BitBLT, alpha blending and image blur/sharpness.

maintainers:
  - Jacob Chen <jacob-chen@iotwrt.com>
  - Ezequiel Garcia <ezequiel@collabora.com>

properties:
  compatible:
    oneOf:
      - const: rockchip,rk3288-rga
      - const: rockchip,rk3399-rga
      - items:
          - const: rockchip,rk3228-rga
          - const: rockchip,rk3288-rga

  reg:
    maxItems: 1

  interrupts:
    maxItems: 1

  clocks:
    maxItems: 3

  clock-names:
    items:
      - const: aclk
      - const: hclk
      - const: sclk

  power-domains:
    maxItems: 1

  resets:
    maxItems: 3

  reset-names:
    items:
      - const: core
      - const: axi
      - const: ahb

required:
  - compatible
  - reg
  - interrupts
  - clocks
  - clock-names
  - resets
  - reset-names

additionalProperties: false

examples:
  - |
    #include <dt-bindings/clock/rk3399-cru.h>
    #include <dt-bindings/interrupt-controller/arm-gic.h>
    #include <dt-bindings/power/rk3399-power.h>
    rga: rga@ff680000 {
      compatible = "rockchip,rk3399-rga";
      reg = <0xff680000 0x10000>;
      interrupts = <GIC_SPI 55 IRQ_TYPE_LEVEL_HIGH>;
      clocks = <&cru ACLK_RGA>,
               <&cru HCLK_RGA>,
               <&cru SCLK_RGA_CORE>;
      clock-names = "aclk", "hclk", "sclk";
      power-domains = <&power RK3399_PD_RGA>;
      resets = <&cru SRST_RGA_CORE>,
               <&cru SRST_A_RGA>,
               <&cru SRST_H_RGA>;
      reset-names = "core", "axi", "ahb";
    };
